import React, { HTMLAttributes } from "react";
export interface DialogFooterProps extends HTMLAttributes<HTMLDivElement> {
    /**
     * An optional alignment for the content within the footer. Since the majority
     * of dialog footers are used to contain action buttons, the default alignment
     * is near the end.
     */
    align?: "none" | "start" | "end" | "between" | "stacked-start" | "stacked-end";
}
declare const DialogFooter: React.ForwardRefExoticComponent<DialogFooterProps & React.RefAttributes<HTMLDivElement>>;
export default DialogFooter;
